#include "hapio.h" 

void
writeans(char *oname, int *pdata, char **lines, int nt, int len)  
/** 
 side effect: lines are chomped 
 lines can be NULL
*/
{
 int i,j,k, slen ;  
 char *sx ;
 FILE *ofile ;

 openit(oname, &ofile, "w") ;

 for (i=0 ; i <nt; i++)  {
  for (j=0 ; j< len; j++) { 
   fprintf(ofile,"%1d", pdata[i*len+j]) ;
  }
  if ((lines != NULL) && (lines[i] != NULL)) {
   slen = strlen(lines[i]) ;
   if (lines[i][slen-1] == '\n')   {
    lines[i][slen-1] = '\0' ;
   }
   sx = fwhite(lines[i]) ;
   if (sx != NULL) {
    fprintf(ofile,"%s",sx) ;
   }
  }
  fprintf(ofile,"\n") ;
 }
 fclose (ofile) ;
}

void
getsize(char *iname, int *nt, int *len)  
{
  char line[MAXSTR] ;
  char *sx ;
  char *spt[MAXFIELD] ;
  FILE *ifile ;
  int nsplit , n, l, oldl ;
  char c ;

  openit(iname, &ifile, "r") ;

 n = 0; 
 l = -1 ;
 while (fgets(line,MAXSTR,ifile) != NULL)  {
  nsplit = splitup(line, spt, MAXFIELD) ;
  sx = spt[0] ;

  c = sx[0] ;
  if (c=='#') { 
   freeup(spt, nsplit) ;
   continue ;
  }

  l = strlen(sx) ;
  if ((n>0) && (l != oldl)) 
    fatalx("(getsize) bad haplength  %s\n%s",iname,line) ;
  ++n ;
  oldl = l ;
  freeup(spt, nsplit) ;
 }
 *nt = n ; 
 *len = l ;
 fclose(ifile) ;
}

void
getdata(char *iname, int *data, int *nt, int *len)  
{
/* data already allocated */

  char line[MAXSTR] ;
  char *sx ;
  char *spt[MAXFIELD] ;
  FILE *ifile ;
  int nsplit , n, l, oldl, k ;
  int i, zzero ;
  char c ;

  openit(iname, &ifile, "r") ;

 n = 0; 
 l = -1 ;
 k=0 ;
 zzero = (int) '0' ;
 while (fgets(line,MAXSTR,ifile) != NULL)  {
  nsplit = splitup(line, spt, MAXFIELD) ;
  sx = spt[0] ;
  c = sx[0] ;
  if (c=='#') { 
   freeup(spt, nsplit) ;
   continue ;
  }
  l = strlen(sx) ;
  if ((n>0) && (l != oldl)) 
    fatalx("(getdata) bad haplength  %s\n%s",iname,line) ;
  ++n ;
  for (i=0; i < l; i++)  {
   data[k] = ((int) *(sx+i) ) - zzero ;
   ++k ;
  }
  oldl = l ;
  freeup(spt, nsplit) ;
 }
 *nt = n ; 
 *len = l ;
 fclose(ifile) ;
}
void
getdatac(char *iname, int *data, double *probs, int *nt, int *len)  
{
/* data already allocated */

  char line[MAXSTR] ;
  char *sx ;
  char *spt[MAXFIELD] ;
  FILE *ifile ;
  int nsplit , n, l, oldl, k ;
  int i, zzero ;

  openit(iname, &ifile, "r") ;

 n = 0; 
 l = -1 ;
 k=0 ;
 zzero = (int) '0' ;
 while (fgets(line,MAXSTR,ifile) != NULL)  {
  nsplit = splitup(line, spt, MAXFIELD) ;

  if (nsplit<2) fatalx("bad line\n", line) ;

  sx = spt[0] ; 
  probs[n] = atof(sx) ;
  
  sx = spt[1] ;
  l = strlen(sx) ;
  if ((n>0) && (l != oldl)) fatalx("(getdatac) bad ifile %s\n%s",iname,line) ;
  ++n ;

  for (i=0; i < l; i++)  {
   data[k] = ((int) *(sx+i) ) - zzero ;
   ++k ;
  }
  oldl = l ;
  freeup(spt, nsplit) ;
 }
 *nt = n ; 
 *len = l ;
 fclose(ifile) ;
}

/** 
 The routines below are not haplo specific 
 ?? may be useful in general
*/

int existq(char *name) 
// YES if file exists else NO  
{
  FILE *fff ;
  if (name==NULL) return NO ;                     
  fff = fopen(name,"r") ;
  if (fff == NULL) return NO ;
  fclose(fff) ;
  return YES ;
}

void printi1(int *a, int n) 
{
  int j ;
  for (j=0; j<n; j++) { 
   printf("%1d",a[j]) ;
  }
  printf ("\n") ;
}


void
getlines(char *iname, char **lines, int *nt)  
{

  char line[MAXSTR] ;
  FILE *ifile ;
  int n  ;

  openit(iname, &ifile, "r") ;

 n = 0; 
 while (fgets(line,MAXSTR,ifile) != NULL)  {
  if (lines != NULL) 
   lines[n] = strdup(line) ;
  ++n ;
 }
 fclose(ifile) ;
 *nt = n ;
}


int
numcols(char *iname)  
{
  char line[MAXSTR] ;
  FILE *ifile ;
  int mcols = 0 ;
  char *spt[MAXFIELD] ;
  int nsplit  ;

  openit(iname, &ifile, "r") ;

 while (fgets(line,MAXSTR,ifile) != NULL)  {
  nsplit = splitup(line, spt, MAXFIELD) ;
  mcols = MAX(mcols, nsplit) ;
  freeup(spt, nsplit) ;
 }

 fclose(ifile) ;
 return mcols ;
}

void
getarray(char *iname, double *data, int *nt, int *cols)  
{
/* data already allocated NOT initialized */

  char line[MAXSTR] ;
  char *sx ;
  char *spt[MAXFIELD] ;
  FILE *ifile ;
  int nsplit , n, l, k ;
  int i, ncols ;
  char c ;

  ncols = *cols ;
  openit(iname, &ifile, "r") ;

 n = 0; 
 l = -1 ;
 while (fgets(line,MAXSTR,ifile) != NULL)  {
  nsplit = splitup(line, spt, MAXFIELD) ;
  if (nsplit==0) continue ; 
  c = spt[0][0] ;
  if (c=='#') { 
   freeup(spt, nsplit) ;
   continue ;
  }
  l = MAX(l, nsplit) ;
  if (nsplit!=ncols) 
   fprintf(stderr,"*** warning col length mismatch\n") ;
  for (i=0; i<nsplit; i++) { 
   data[n*ncols+i] = atof(spt[i]) ;
  }
  freeup(spt, nsplit) ;
  ++n ;
 }
 *nt = n ; 
 *cols = l ;
 fclose(ifile) ;
}


void
setbase(int *base1, int *base2, int *idata, 
 int nt, int len) 
{
 int i, j, k, nbase ;    

 ivclear(base1, -1, len) ;
 ivclear(base2, -1, len) ;

 for (j=0; j<len; j++) {  
  nbase = 0;
  for (i=0; i<nt; i++)  {  
   if (nbase >=2) break ;
   k = idata[i*len+j] ;
   if (k<=0) continue ;
   if (k>4) continue ;
   if (base1[j] < 0) {  
    base1[j] = k ;
    ++nbase ;
   }
   if (base1[j] == k) continue ;
   base2[j] = k ;
   ++nbase ;
  }
  if (base1[j]<0) { 
   base1[j] = 1; base2[j] = 2;
  }
  if (base2[j]<0) { 
   base2[j] = 1; 
   if (base1[j] == 1) base2[j] = 2 ;
  }
 }
}
int validb(int k) 
/* YES if k is valid base */
{
    if ((k<=0) || (k==HVAL)) return NO ;
    return YES ;
}
