#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <math.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <nicklib.h>
#include <getpars.h>


typedef struct { 
  int nnode ; 
  int nedge ;
  int *isleaf ; 
  int *label ; 
  int root ;  
  int *matrix ;  
} GRAPH ;

#define MAXGRAPH 100
GRAPH *grph[100] ; 
int ngraph = 0 ;

int  nodenum(GRAPH *gg, int label)  ;
void addedge(GRAPH *g2, GRAPH *g1, int oldnode, int newlabel, int isleaf)   ;
void addnode(GRAPH *gg, GRAPH *g1, int oldedge, int newlabel)   ;
int wnode (GRAPH *gpt, int lab1, int lab2) ;
void trivgraph(GRAPH *gg, int label) ;
void gdestroy(GRAPH **gg)  ;
void copygraph(GRAPH *g1, GRAPH *g2) ;


int main()
{
 GRAPH *g1, *g2, *gg, *oldgg ;
 int k, n, e  ;
 int node1, node2 ;
 
 for (k=0; k< MAXGRAPH; ++k) {  
  ZALLOC(grph[k], 1, GRAPH) ;
 }

 g1 = grph[ngraph] ; 
 trivgraph(g1, 1) ;  
 ++ngraph ; 
 oldgg=grph[ngraph-1] ; gg = grph[ngraph] ;
 addedge (gg, oldgg, 0, 2, YES) ;  
 ++ngraph  ;

 n = gg -> nnode ; 
 e = gg -> nedge ;

 printf("matrix: \n") ; 
 printimat(gg -> matrix, n, e) ;

 oldgg=grph[ngraph-1] ; gg = grph[ngraph] ;
 k = wnode(oldgg, 1, 2) ;
 addnode (gg, oldgg, k, 12) ;  
 node1 = nodenum(gg, 12) ;
 ++ngraph ;
 
 n = gg -> nnode ; 
 e = gg -> nedge ;

 printf("matrix: \n") ; 
 printimat(gg -> matrix, n, e) ;

 oldgg=grph[ngraph-1] ; gg = grph[ngraph] ;
 addedge (gg, oldgg, node1, 13, NO) ;  
 node2 = nodenum(gg, 13) ;


 ++ngraph ; oldgg=grph[ngraph-1] ; gg = grph[ngraph] ;
 addedge (gg, oldgg, node2, 4, YES) ;  

 ++ngraph ; oldgg=grph[ngraph-1] ; gg = grph[ngraph] ;
 addedge (gg, oldgg, node2, 5, YES) ;  

 n = gg -> nnode ; 
 e = gg -> nedge ;

 printf("matrix: \n") ; 
 printimat(gg -> matrix, n, e) ;

 
}
int  nodenum(GRAPH *gg, int label) 
{
 int i, n ;

 n = gg -> nnode ;
 for (i=0; i<n ; ++i)  {  
  if (gg -> label[i] == label) return i ; 
 }
 return -1 ;

}



int wnode (GRAPH *gpt, int lab1, int lab2) 
// return edge number joining nodes with label lab1, lab2
{

 int k, n, e, a1= 0, a2 = 0, t1, t2, i ;
 e = gpt -> nedge ;
 n = gpt -> nnode ;
 t1 = t2 = -1 ;
 for (i=0; i<n ; ++i)  {  
  if (gpt -> label[i] == lab1) t1 = i ;
  if (gpt -> label[i] == lab2) t2 = i ;
 }

 if (t1<0) return -1 ;
 if (t2<0) return -1 ;

 e = gpt -> nedge ;
 for (k=0; k<e ; ++k)  {  
  a1 = a2 = NO ;
  if (gpt -> matrix[t1*e+k] != 0)  a1 = YES ;                      
  if (gpt -> matrix[t1*e+k] != 0)  a2 = YES ; 
  if (a1 && a2)  break ;
 }
 if (k>=e) return -1 ;
 
 return k ;

}

void gdestroy(GRAPH **gg) 
{
  GRAPH *xx ;

  xx = *gg ;
  
  if (xx->matrix != NULL) free(xx->matrix) ;
  if (xx->label != NULL)  free(xx->label) ;
  if (xx->isleaf != NULL) free(xx->isleaf) ;
  free(xx) ;

}

void trivgraph(GRAPH *gg, int label) 
{
  GRAPH *xx ;

  xx = gg ;  
  xx -> nnode = 1 ; 
  xx -> nedge = 0 ;
  ZALLOC(xx -> isleaf, 1, int) ;  
  ZALLOC(xx -> label, 1, int) ;  
  xx -> isleaf[0] = YES ;
  xx -> label[0] = label ;
  xx -> root = 0 ;  
}
void
addedge(GRAPH *gg, GRAPH *g1, int oldnode, int newlabel, int isleaf)   
{
  GRAPH *xx, *x ;
  int n, e, i, j ;

  x = g1 ;
  xx = gg ;  
  n = xx -> nnode = x -> nnode + 1 ; 
  e = xx -> nedge = x -> nedge + 1 ; 
  ZALLOC(xx -> isleaf, n, int) ;  
  copyiarr(x -> isleaf, xx -> isleaf, n-1) ; xx->isleaf[n-1] = isleaf ;
  ZALLOC(xx -> label, n, int) ;  
  copyiarr(x -> label, xx -> label, n-1) ; xx->label[n-1] = newlabel ;
  xx -> root = x -> root ;  
  ZALLOC(xx -> matrix, n*e, int) ;
  for (i=0; i<n-1; i++)  {  
   for (j=0; j<e-1; j++)  {  
    xx ->matrix[i*e+j] = x->matrix[i*(e-1)+j] ;
   }
  }
  i = oldnode ; j = e-1 ; 
  xx -> matrix[i*e+j] = 1 ; // ancestor
  i = n-1 ; j = e-1 ; 
  xx -> matrix[i*e+j] = -1 ; //child
}
void
copygraph(GRAPH *g1, GRAPH *g2) 
{
  GRAPH *xx, *x ;
  int n, e, i, j ;

  xx = g2 ;  
  x = g1 ;
  n = xx -> nnode = x -> nnode  ; 
  e = xx -> nedge = x -> nedge  ; 

  ZALLOC(xx -> isleaf, n, int) ;  
  copyiarr(x -> isleaf, xx -> isleaf, n) ;
  ZALLOC(xx -> label, n, int) ;  
  copyiarr(x -> label, xx -> label, n) ; 
  xx -> root = x -> root ;  
  ZALLOC(xx -> matrix, n*e, int) ;
  copyiarr(x -> matrix, xx -> matrix, n*e) ; 
}
void
addnode(GRAPH *gg, GRAPH *g1, int oldedge, int newlabel)   
{

  GRAPH *xx, *x ;
  int n, e, i, j, newn, newe ;


  x = g1 ;
  xx = gg ;  
  n = xx -> nnode = x -> nnode + 1 ; 
  e = xx -> nedge = x -> nedge + 1 ; 
  ZALLOC(xx -> isleaf, n, int) ;  
  copyiarr(x -> isleaf, xx -> isleaf, n-1) ; xx->isleaf[n-1] = NO ;
  ZALLOC(xx -> label, n, int) ;  
  copyiarr(x -> label, xx -> label, n-1) ; xx->label[n-1] = newlabel ;
  xx -> root = x -> root ;  
  ZALLOC(xx -> matrix, n*e, int) ;

  for (i=0; i<n-1; i++)  {  
   for (j=0; j<e-1; j++)  {  
    if (j==oldedge) continue ;
    xx ->matrix[i*e+j] = x->matrix[i*(e-1)+j] ;
   }
  }

  j = oldedge ;             
  newn = n-1 ;
  newe = e-1 ;
  xx -> matrix[newn*e+newe] = 1 ;
  xx -> matrix[newn*e+j] = -1 ;
  for (i=0; i<n-1; i++)  {  
   if (x -> matrix[i*(e-1)+j] == 1) {  
    xx -> matrix[i*e+j] = 1 ;
   }
   if (x -> matrix[i*(e-1)+j] == -1) {  
    xx -> matrix[i*e+newe] = -1 ;
   }
  }

}



